Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class GroupByIterator

    java.lang.Object
      net.sf.saxon.sort.GroupByIterator

All Implemented Interfaces:
  GroupIterator, LastPositionFinder, SequenceIterator

public class GroupByIterator
extends java.lang.Object
implements GroupIterator, LastPositionFinder

A GroupByIterator iterates over a sequence of groups defined by xsl:for-each-group group-by="x". The groups are returned in order of first appearance. Note that an item can appear in several groups; indeed, an item may be the leading item of more than one group, which means that knowing the leading item is not enough to know the current group.

The GroupByIterator acts as a SequenceIterator, where successive calls of next() return the leading item of each group in turn. The current item of the iterator is therefore the leading item of the current group. To get access to all the members of the current group, the method iterateCurrentGroup() is used; this underpins the current-group() function in XSLT. The grouping key for the current group is available via the getCurrentGroupingKey() method.

Constructor Summary
`GroupByIterator(SequenceIterator population, Expression keyExpression, XPathContext keyContext, java.util.Comparator collator)` Create a GroupByIterator

Method Summary
`Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`java.util.List` | `getCurrentGroup()` Get the contents of the current group as a java List
`AtomicValue` | `getCurrentGroupingKey()` Get the value of the grouping key for the current group
`int` | `getLastPosition()` Get the last position (that is, the number of groups)
`SequenceIterator` | `iterateCurrentGroup()` Get an iterator over the items in the current group
`Item` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### GroupByIterator

    public GroupByIterator(SequenceIterator population,
                           Expression keyExpression,
                           XPathContext keyContext,
                           java.util.Comparator collator)
                    throws XPathException

  Create a GroupByIterator

Parameters:
  `population` - iterator over the population to be grouped
  `keyExpression` - the expression used to calculate the grouping key
  `keyContext` - dynamic context for calculating the grouping key
  `collator` - Collation to be used for comparing grouping keys
Throws:
  `XPathException`

Method Detail

### getCurrentGroupingKey

    public AtomicValue getCurrentGroupingKey()

  Get the value of the grouping key for the current group

  Specified by:
    `getCurrentGroupingKey` in interface `GroupIterator`
  Returns:
    the grouping key

### iterateCurrentGroup

    public SequenceIterator iterateCurrentGroup()

  Get an iterator over the items in the current group

  Specified by:
    `iterateCurrentGroup` in interface `GroupIterator`
  Returns:
    the iterator

### getCurrentGroup

    public java.util.List getCurrentGroup()

  Get the contents of the current group as a java List

  Returns:
    the contents of the current group

### next

    public Item next()
              throws XPathException

  Description copied from interface: `SequenceIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Description copied from interface: `SequenceIterator`
  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next().

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(); or null, if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Description copied from interface: `SequenceIterator`
  Get the current position. This will be zero before the first call on next(), otherwise it will be the number of times that next() has been called.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next()

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Description copied from interface: `SequenceIterator`
  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs

### getLastPosition

    public int getLastPosition()
                        throws XPathException

  Get the last position (that is, the number of groups)

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD